Index: boot/Makefile
===================================================================
--- boot/Makefile	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ boot/Makefile	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -48,5 +48,5 @@
 endif
 ifeq ($(RDFMT),fat)
-	$(MKFAT) 1048576 $(DIST_PATH) $@
+	$(MKFAT) $(DIST_PATH) $@
 endif
 
Index: boot/Makefile.build
===================================================================
--- boot/Makefile.build	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ boot/Makefile.build	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -61,11 +61,4 @@
 	GCC_CFLAGS += -Werror
 	ICC_CFLAGS += -Werror
-endif
-
-ifeq ($(CONFIG_LINE_DEBUG),y)
-	GCC_CFLAGS += -g
-	ICC_CFLAGS += -g
-	SUNCC_CFLAGS += -g
-	CLANG_CFLAGS += -g
 endif
 
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ boot/arch/arm32/Makefile.inc	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -41,7 +41,5 @@
 PAGE_SIZE = 4096
 
-RD_SRVS_ESSENTIAL += \
-	$(USPACE_PATH)/srv/hid/s3c24xx_ts/s3c24ts \
-	$(USPACE_PATH)/srv/hw/char/s3c24xx_uart/s3c24ser
+RD_SRVS_ESSENTIAL +=
 
 RD_SRVS_NON_ESSENTIAL += \
Index: boot/arch/mips32/src/Makefile
===================================================================
--- boot/arch/mips32/src/Makefile	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ boot/arch/mips32/src/Makefile	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -32,13 +32,9 @@
 .PHONY: all clean
 
-all: ../../../../version ../../../../Makefile.common ../../../../Makefile.config ../../../../config.h
+all: ../../../../version ../../../../Makefile.config ../../../../config.h ../../../../config.defs
 	-[ -f $(DEPEND) ] && mv -f $(DEPEND) $(DEPEND_PREV)
 	$(MAKE) -f Makefile.build PRECHECK=$(PRECHECK)
 
 clean:
-	rm -f $(USPACEDIR)/dist/srv/*
-	rm -f $(USPACEDIR)/dist/app/*
-	rm -f $(USPACEDIR)/dist/cfg/net/*
-
 	for file in $(RD_SRVS) ; do \
 		rm -f $(USPACEDIR)/dist/srv/`basename $$file` ; \
@@ -47,7 +43,4 @@
 		rm -f $(USPACEDIR)/dist/app/`basename $$file` ; \
 	done
-	for file in $(NET_CFG) ; do \
-		rm -f $(USPACEDIR)/dist/cfg/net/`basename $$file` ; \
-	done
 	rm -f $(DEPEND) $(DEPEND_PREV) $(JOB) $(OUTPUT) $(RAW) $(COMPS).h $(COMPS).c $(LINK) $(INITRD).img $(INITRD).fs
 	find . -name '*.o' -follow -exec rm \{\} \;
Index: boot/arch/mips32/src/Makefile.build
===================================================================
--- boot/arch/mips32/src/Makefile.build	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ boot/arch/mips32/src/Makefile.build	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -32,6 +32,6 @@
 
 include ../../../../version
-include ../../../../Makefile.common
 include ../../../../Makefile.config
+include ../../../../config.defs
 include Makefile.common
 include Makefile.toolchain
@@ -77,8 +77,4 @@
 
 $(DEPEND):
-	rm -f $(USPACEDIR)/dist/srv/*
-	rm -f $(USPACEDIR)/dist/app/*
-	rm -f $(USPACEDIR)/dist/cfg/net/*
-
 	for file in $(RD_SRVS) ; do \
 		cp $$file $(USPACEDIR)/dist/srv/ ; \
@@ -86,7 +82,4 @@
 	for file in $(RD_APPS) ; do \
 		cp $$file $(USPACEDIR)/dist/app/ ; \
-	done
-	for file in $(NET_CFG) ; do \
-		cp $$file $(USPACEDIR)/dist/cfg/net/ ; \
 	done
 ifeq ($(RDFMT),tmpfs)
Index: boot/arch/mips32/src/Makefile.toolchain
===================================================================
--- boot/arch/mips32/src/Makefile.toolchain	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ boot/arch/mips32/src/Makefile.toolchain	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -27,5 +27,14 @@
 #
 
+## Toolchain configuration
+#
+
+ifndef CROSS_PREFIX
+	CROSS_PREFIX = /usr/local
+endif
+
 BFD_ARCH = mips
+TARGET = mipsel-linux-gnu
+TOOLCHAIN_DIR = $(CROSS_PREFIX)/mips32/bin
 
 JOBFILE = ../../../../tools/jobfile.py
@@ -39,4 +48,6 @@
 	BFD_NAME = elf32-tradbigmips
 	BFD = ecoff-bigmips
+	TOOLCHAIN_DIR = $(CROSS_PREFIX)/mips32eb/bin
+	TARGET = mips-linux-gnu
 endif
 
@@ -44,4 +55,20 @@
 	BFD_NAME = elf32-tradlittlemips
 	BFD = binary
+endif
+
+ifeq ($(COMPILER),gcc_native)
+	CC = gcc
+	AS = as
+	LD = ld
+	OBJCOPY = objcopy
+	OBJDUMP = objdump
+endif
+
+ifeq ($(COMPILER),gcc_cross)
+	CC = $(TOOLCHAIN_DIR)/$(TARGET)-gcc
+	AS = $(TOOLCHAIN_DIR)/$(TARGET)-as
+	LD = $(TOOLCHAIN_DIR)/$(TARGET)-ld
+	OBJCOPY = $(TOOLCHAIN_DIR)/$(TARGET)-objcopy
+	OBJDUMP = $(TOOLCHAIN_DIR)/$(TARGET)-objdump
 endif
 
Index: contrib/conf/ia32-qe.sh
===================================================================
--- contrib/conf/ia32-qe.sh	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ contrib/conf/ia32-qe.sh	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -5,5 +5,5 @@
 # Create a disk image if it does not exist
 if [ ! -f "$DISK_IMG" ]; then
-	tools/mkfat.py 1048576 uspace/dist/data "$DISK_IMG"
+	tools/mkfat.py uspace/dist/data "$DISK_IMG"
 fi
 
Index: contrib/conf/mips32-gx.sh
===================================================================
--- contrib/conf/mips32-gx.sh	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ contrib/conf/mips32-gx.sh	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -5,5 +5,5 @@
 # Create a disk image if it does not exist
 if [ ! -f "$DISK_IMG" ]; then
-	tools/mkfat.py 1048576 uspace/dist/data "$DISK_IMG"
+	tools/mkfat.py uspace/dist/data "$DISK_IMG"
 fi
 
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/Makefile	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -120,11 +120,4 @@
 ifeq ($(CONFIG_LTO),y)
 	GCC_CFLAGS += -flto
-endif
-
-ifeq ($(CONFIG_LINE_DEBUG),y)
-	GCC_CFLAGS += -g
-	ICC_CFLAGS += -g
-	SUNCC_CFLAGS += -g
-	CLANG_CFLAGS += -g
 endif
 
@@ -408,9 +401,5 @@
 
 $(DISASM): $(RAW)
-ifeq ($(CONFIG_LINE_DEBUG),y)
-	$(OBJDUMP) -d -S $< > $@
-else
 	$(OBJDUMP) -d $< > $@
-endif
 
 $(RAW): $(LINK) $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(SYMTAB_OBJECTS)
Index: kernel/arch/amd64/_link.ld.in
===================================================================
--- kernel/arch/amd64/_link.ld.in	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/_link.ld.in	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -53,17 +53,4 @@
 	}
 	
-#ifdef CONFIG_LINE_DEBUG
-	.comment 0 : { *(.comment); }
-	.debug_abbrev 0 : { *(.debug_abbrev); }
-	.debug_aranges 0 : { *(.debug_aranges); }
-	.debug_info 0 : { *(.debug_info); }
-	.debug_line 0 : { *(.debug_line); }
-	.debug_loc 0 : { *(.debug_loc); }
-	.debug_pubnames 0 : { *(.debug_pubnames); }
-	.debug_pubtypes 0 : { *(.debug_pubtypes); }
-	.debug_ranges 0 : { *(.debug_ranges); }
-	.debug_str 0 : { *(.debug_str); }
-#endif
-	
 	/DISCARD/ : {
 		*(*);
Index: kernel/arch/amd64/include/pm.h
===================================================================
--- kernel/arch/amd64/include/pm.h	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/include/pm.h	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -65,5 +65,6 @@
 #endif /* CONFIG_FB */
 
-#define GDT_SELECTOR(des)  ((des) << 3)
+#define gdtselector(des)  ((des) << 3)
+#define idtselector(des)  ((des) << 4)
 
 #define PL_KERNEL  0
@@ -167,4 +168,5 @@
 
 extern ptr_16_64_t gdtr;
+extern ptr_16_32_t bootstrap_gdtr;
 extern ptr_16_32_t protected_ap_gdtr;
 
Index: kernel/arch/amd64/src/asm.S
===================================================================
--- kernel/arch/amd64/src/asm.S	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/asm.S	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -244,5 +244,5 @@
 	 */
 	xorq %rdx, %rdx
-	cmpq $(GDT_SELECTOR(KTEXT_DES)), ISTATE_OFFSET_CS(%rsp)
+	cmpq $(gdtselector(KTEXT_DES)), ISTATE_OFFSET_CS(%rsp)
 	cmovnzq %rdx, %rbp
 
Index: kernel/arch/amd64/src/boot/boot.S
===================================================================
--- kernel/arch/amd64/src/boot/boot.S	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/boot/boot.S	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -85,5 +85,5 @@
 	
 	/* Kernel data + stack */
-	movw $GDT_SELECTOR(KDATA_DES), %cx
+	movw $gdtselector(KDATA_DES), %cx
 	movw %cx, %es
 	movw %cx, %ds
@@ -94,9 +94,9 @@
 	 * when _visible_ part of GS does not point to user-mode segment.
 	 */
-	movw $GDT_SELECTOR(UDATA_DES), %cx
+	movw $gdtselector(UDATA_DES), %cx
 	movw %cx, %fs
 	movw %cx, %gs
 	
-	jmpl $GDT_SELECTOR(KTEXT32_DES), $multiboot_meeting_point
+	jmpl $gdtselector(KTEXT32_DES), $multiboot_meeting_point
 	multiboot_meeting_point:
 	
@@ -182,5 +182,5 @@
 	
 	/* At this point we are in compatibility mode */
-	jmpl $GDT_SELECTOR(KTEXT_DES), $start64
+	jmpl $gdtselector(KTEXT_DES), $start64
 
 /** Print string to EGA display (in light red) and halt.
@@ -645,6 +645,7 @@
 .section K_DATA_START, "aw", @progbits
 
+.global bootstrap_gdtr
 bootstrap_gdtr:
-	.word GDT_SELECTOR(GDT_ITEMS)
+	.word gdtselector(GDT_ITEMS)
 	.long KA2PA(gdt)
 
Index: kernel/arch/amd64/src/boot/vesa_ret.inc
===================================================================
--- kernel/arch/amd64/src/boot/vesa_ret.inc	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/boot/vesa_ret.inc	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -7,5 +7,5 @@
 	
 	/* Kernel data + stack */
-	movw $GDT_SELECTOR(KDATA_DES), %cx
+	movw $gdtselector(KDATA_DES), %cx
 	movw %cx, %es
 	movw %cx, %ds
@@ -17,7 +17,7 @@
 	 */
 	
-	movw $GDT_SELECTOR(UDATA_DES), %cx
+	movw $gdtselector(UDATA_DES), %cx
 	movw %cx, %fs
 	movw %cx, %gs
 	
-	jmpl $GDT_SELECTOR(KTEXT32_DES), $vesa_meeting_point
+	jmpl $gdtselector(KTEXT32_DES), $vesa_meeting_point
Index: kernel/arch/amd64/src/ddi/ddi.c
===================================================================
--- kernel/arch/amd64/src/ddi/ddi.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/ddi/ddi.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -153,5 +153,5 @@
 	tss_descriptor_t *tss_desc = (tss_descriptor_t *) &gdt_p[TSS_DES];
 	tss_desc->type = AR_TSS;
-	tr_load(GDT_SELECTOR(TSS_DES));
+	tr_load(gdtselector(TSS_DES));
 	
 	/*
Index: kernel/arch/amd64/src/pm.c
===================================================================
--- kernel/arch/amd64/src/pm.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/pm.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -171,5 +171,5 @@
 
 		d->unused = 0;
-		d->selector = GDT_SELECTOR(KTEXT_DES);
+		d->selector = gdtselector(KTEXT_DES);
 
 		d->present = 1;
@@ -291,5 +291,5 @@
 	 * to its own TSS. We just need to load the TR register.
 	 */
-	tr_load(GDT_SELECTOR(TSS_DES));
+	tr_load(gdtselector(TSS_DES));
 }
 
Index: kernel/arch/amd64/src/smp/ap.S
===================================================================
--- kernel/arch/amd64/src/smp/ap.S	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/smp/ap.S	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -61,13 +61,13 @@
 	orl $1, %eax
 	movl %eax, %cr0     # switch to protected mode
-	jmpl $GDT_SELECTOR(KTEXT32_DES), $jump_to_kernel - BOOT_OFFSET + AP_BOOT_OFFSET
+	jmpl $gdtselector(KTEXT32_DES), $jump_to_kernel - BOOT_OFFSET + AP_BOOT_OFFSET
 
 jump_to_kernel:
 .code32
-	movw $GDT_SELECTOR(KDATA_DES), %ax
+	movw $gdtselector(KDATA_DES), %ax
 	movw %ax, %ds
 	movw %ax, %es
 	movw %ax, %ss
-	movw $GDT_SELECTOR(UDATA_DES), %ax
+	movw $gdtselector(UDATA_DES), %ax
 	movw %ax, %gs
 	
@@ -94,5 +94,5 @@
 	
 	# At this point we are in compatibility mode
-	jmpl $GDT_SELECTOR(KTEXT_DES), $start64 - BOOT_OFFSET + AP_BOOT_OFFSET
+	jmpl $gdtselector(KTEXT_DES), $start64 - BOOT_OFFSET + AP_BOOT_OFFSET
 
 .code64
Index: kernel/arch/amd64/src/syscall.c
===================================================================
--- kernel/arch/amd64/src/syscall.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/syscall.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -58,6 +58,6 @@
 	 */
 	write_msr(AMD_MSR_STAR,
-	    ((uint64_t) (GDT_SELECTOR(KDATA_DES) | PL_USER) << 48) |
-	    ((uint64_t) (GDT_SELECTOR(KTEXT_DES) | PL_KERNEL) << 32));
+	    ((uint64_t)(gdtselector(KDATA_DES) | PL_USER) << 48) |
+	    ((uint64_t)(gdtselector(KTEXT_DES) | PL_KERNEL) << 32));
 	write_msr(AMD_MSR_LSTAR, (uint64_t)syscall_entry);
 	/* Mask RFLAGS on syscall 
Index: kernel/arch/amd64/src/userspace.c
===================================================================
--- kernel/arch/amd64/src/userspace.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/amd64/src/userspace.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -65,8 +65,8 @@
 		"xorq %%rdi, %%rdi\n"
 		"iretq\n"
-		:: [udata_des] "i" (GDT_SELECTOR(UDATA_DES) | PL_USER),
+		:: [udata_des] "i" (gdtselector(UDATA_DES) | PL_USER),
 		   [stack_size] "r" (kernel_uarg->uspace_stack + THREAD_STACK_SIZE),
 		   [ipl] "r" (ipl),
-		   [utext_des] "i" (GDT_SELECTOR(UTEXT_DES) | PL_USER),
+		   [utext_des] "i" (gdtselector(UTEXT_DES) | PL_USER),
 		   [entry] "r" (kernel_uarg->uspace_entry),
 		   [uarg] "r" (kernel_uarg->uspace_uarg)
Index: kernel/arch/arm32/include/mach/integratorcp/integratorcp.h
===================================================================
--- kernel/arch/arm32/include/mach/integratorcp/integratorcp.h	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/arm32/include/mach/integratorcp/integratorcp.h	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -105,5 +105,4 @@
 extern void icp_get_memory_extents(uintptr_t *, uintptr_t *);
 extern void icp_frame_init(void);
-extern size_t icp_get_irq_count(void);
 
 extern struct arm_machine_ops icp_machine_ops;
Index: kernel/arch/arm32/include/mach/testarm/testarm.h
===================================================================
--- kernel/arch/arm32/include/mach/testarm/testarm.h	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/arm32/include/mach/testarm/testarm.h	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -73,5 +73,4 @@
 extern void gxemul_get_memory_extents(uintptr_t *, uintptr_t *);
 extern void gxemul_frame_init(void);
-extern size_t gxemul_get_irq_count(void);
 
 extern struct arm_machine_ops gxemul_machine_ops;
Index: kernel/arch/arm32/include/machine_func.h
===================================================================
--- kernel/arch/arm32/include/machine_func.h	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/arm32/include/machine_func.h	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -55,5 +55,4 @@
 	void (*machine_output_init)(void);
 	void (*machine_input_init)(void);
-	size_t (*machine_get_irq_count)(void);
 };
 
Index: kernel/arch/arm32/src/mach/gta02/gta02.c
===================================================================
--- kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/arm32/src/mach/gta02/gta02.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -43,6 +43,4 @@
 #include <genarch/drivers/s3c24xx_irqc/s3c24xx_irqc.h>
 #include <genarch/drivers/s3c24xx_timer/s3c24xx_timer.h>
-#include <genarch/srln/srln.h>
-#include <sysinfo/sysinfo.h>
 #include <interrupt.h>
 #include <ddi/ddi.h>
@@ -70,5 +68,4 @@
 static void gta02_output_init(void);
 static void gta02_input_init(void);
-static size_t gta02_get_irq_count(void);
 
 static void gta02_timer_irq_init(void);
@@ -77,6 +74,6 @@
 static void gta02_timer_irq_handler(irq_t *irq);
 
-static outdev_t *gta02_scons_dev;
-static s3c24xx_irqc_t gta02_irqc;
+static void *gta02_scons_out;
+static s3c24xx_irqc_t *gta02_irqc;
 static s3c24xx_timer_t *gta02_timer;
 
@@ -91,17 +88,21 @@
 	gta02_frame_init,
 	gta02_output_init,
-	gta02_input_init,
-	gta02_get_irq_count
+	gta02_input_init
 };
 
 static void gta02_init(void)
 {
-	s3c24xx_irqc_regs_t *irqc_regs;
-
+	gta02_scons_out = (void *) hw_map(GTA02_SCONS_BASE, PAGE_SIZE);
+	gta02_irqc = (void *) hw_map(S3C24XX_IRQC_ADDRESS, PAGE_SIZE);
 	gta02_timer = (void *) hw_map(S3C24XX_TIMER_ADDRESS, PAGE_SIZE);
-	irqc_regs = (void *) hw_map(S3C24XX_IRQC_ADDRESS, PAGE_SIZE);
-
-	/* Initialize interrupt controller. */
-	s3c24xx_irqc_init(&gta02_irqc, irqc_regs);
+
+	/* Make all interrupt sources use IRQ mode (not FIQ). */
+	pio_write_32(&gta02_irqc->intmod, 0x00000000);
+
+	/* Disable all interrupt sources. */
+	pio_write_32(&gta02_irqc->intmsk, 0xffffffff);
+
+	/* Disable interrupts from all sub-sources. */
+	pio_write_32(&gta02_irqc->intsubmsk, 0xffffffff);
 }
 
@@ -131,9 +132,5 @@
 	uint32_t inum;
 
-	/* Determine IRQ number. */
-	inum = s3c24xx_irqc_inum_get(&gta02_irqc);
-
-	/* Clear interrupt condition in the interrupt controller. */
-	s3c24xx_irqc_clear(&gta02_irqc, inum);
+	inum = pio_read_32(&gta02_irqc->intoffset);
 
 	irq_t *irq = irq_dispatch_and_lock(inum);
@@ -147,4 +144,8 @@
 		    CPU->id, inum);
 	}
+
+	/* Clear interrupt condition in the interrupt controller. */
+	pio_write_32(&gta02_irqc->srcpnd, S3C24XX_INT_BIT(inum));
+	pio_write_32(&gta02_irqc->intpnd, S3C24XX_INT_BIT(inum));
 }
 
@@ -175,62 +176,13 @@
 	}
 #endif
-
-	/* Initialize serial port of the debugging console. */
-	s3c24xx_uart_io_t *scons_io;
-
-	scons_io = (void *) hw_map(GTA02_SCONS_BASE, PAGE_SIZE);
-	gta02_scons_dev = s3c24xx_uart_init(scons_io, S3C24XX_INT_UART2);
-
-	if (gta02_scons_dev) {
-		/* Create output device. */
-		stdout_wire(gta02_scons_dev);
-	}
-
-	/*
-	 * This is the necessary evil until the userspace driver is entirely
-	 * self-sufficient.
-	 */
-	sysinfo_set_item_val("s3c24xx_uart", NULL, true);
-	sysinfo_set_item_val("s3c24xx_uart.inr", NULL, S3C24XX_INT_UART2);
-	sysinfo_set_item_val("s3c24xx_uart.address.physical", NULL,
-	    (uintptr_t) GTA02_SCONS_BASE);
-
+	outdev_t *scons_dev;
+
+	scons_dev = s3c24xx_uart_init((ioport8_t *) gta02_scons_out);
+	if (scons_dev)
+		stdout_wire(scons_dev);
 }
 
 static void gta02_input_init(void)
 {
-	s3c24xx_uart_t *scons_inst;
-
-	if (gta02_scons_dev) {
-		/* Create input device. */
-		scons_inst = (void *) gta02_scons_dev->data;
-
-		srln_instance_t *srln_instance = srln_init();
-		if (srln_instance) {
-			indev_t *sink = stdin_wire();
-			indev_t *srln = srln_wire(srln_instance, sink);
-			s3c24xx_uart_input_wire(scons_inst, srln);
-
-			/* Enable interrupts from UART2 */
-			s3c24xx_irqc_src_enable(&gta02_irqc,
-			    S3C24XX_INT_UART2);
-
-			/* Enable interrupts from UART2 RXD */
-			s3c24xx_irqc_subsrc_enable(&gta02_irqc,
-			    S3C24XX_SUBINT_RXD2);
-		}
-	}
-
-	/* Enable interrupts from ADC */
-	s3c24xx_irqc_src_enable(&gta02_irqc, S3C24XX_INT_ADC);
-
-	/* Enable interrupts from ADC sub-sources */
-	s3c24xx_irqc_subsrc_enable(&gta02_irqc, S3C24XX_SUBINT_ADC_S);
-	s3c24xx_irqc_subsrc_enable(&gta02_irqc, S3C24XX_SUBINT_TC);
-}
-
-size_t gta02_get_irq_count(void)
-{
-	return GTA02_IRQ_COUNT;
 }
 
@@ -296,5 +248,6 @@
 
 	/* Enable interrupts from timer0 */
-	s3c24xx_irqc_src_enable(&gta02_irqc, S3C24XX_INT_TIMER0);
+	pio_write_32(&gta02_irqc->intmsk, pio_read_32(&gta02_irqc->intmsk) &
+	    ~S3C24XX_INT_BIT(S3C24XX_INT_TIMER0));
 
 	/* Load data from tcntb0/tcmpb0 into tcnt0/tcmp0. */
Index: kernel/arch/arm32/src/mach/integratorcp/integratorcp.c
===================================================================
--- kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -64,6 +64,5 @@
 	icp_frame_init,
 	icp_output_init,
-	icp_input_init,
-	icp_get_irq_count
+	icp_input_init
 };
 
@@ -337,8 +336,4 @@
 }
 
-size_t icp_get_irq_count(void)
-{
-	return ICP_IRQ_COUNT;
-}
 
 /** @}
Index: kernel/arch/arm32/src/mach/testarm/testarm.c
===================================================================
--- kernel/arch/arm32/src/mach/testarm/testarm.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/arm32/src/mach/testarm/testarm.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -64,6 +64,5 @@
 	gxemul_frame_init,
 	gxemul_output_init,
-	gxemul_input_init,
-	gxemul_get_irq_count
+	gxemul_input_init
 };
 
@@ -127,9 +126,4 @@
 }
 
-size_t gxemul_get_irq_count(void)
-{
-	return GXEMUL_IRQ_COUNT;
-}
-
 /** Starts gxemul Real Time Clock device, which asserts regular interrupts.
  *
Index: kernel/arch/arm32/src/machine_func.c
===================================================================
--- kernel/arch/arm32/src/machine_func.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/arm32/src/machine_func.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -128,5 +128,16 @@
 size_t machine_get_irq_count(void)
 {
-	return (machine_ops->machine_get_irq_count)();
+	size_t irq_count;
+ 
+#if defined(MACHINE_gta02)
+	irq_count = GTA02_IRQ_COUNT;
+#elif defined(MACHINE_testarm)
+	irq_count = GXEMUL_IRQ_COUNT;
+#elif defined(MACHINE_integratorcp)
+	irq_count = ICP_IRQ_COUNT;
+#else
+#error Machine type not defined.
+#endif
+	return irq_count;
 }
 
Index: kernel/arch/ia32/include/bios/bios.h
===================================================================
--- kernel/arch/ia32/include/bios/bios.h	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/include/bios/bios.h	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -38,4 +38,6 @@
 #include <typedefs.h>
 
+#define BIOS_EBDA_PTR  0x40e
+
 extern uintptr_t ebda;
 
Index: kernel/arch/ia32/include/pm.h
===================================================================
--- kernel/arch/ia32/include/pm.h	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/include/pm.h	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -58,5 +58,5 @@
 #endif /* CONFIG_FB */
 
-#define GDT_SELECTOR(des)  ((des) << 3)
+#define gdtselector(des)  ((des) << 3)
 
 #define PL_KERNEL  0
@@ -153,4 +153,5 @@
 
 extern ptr_16_32_t gdtr;
+extern ptr_16_32_t bootstrap_gdtr;
 extern ptr_16_32_t protected_ap_gdtr;
 extern tss_t *tss_p;
Index: kernel/arch/ia32/src/asm.S
===================================================================
--- kernel/arch/ia32/src/asm.S	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/asm.S	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -225,5 +225,5 @@
 	 * Switch to kernel selectors.
 	 */
-	movw $(GDT_SELECTOR(KDATA_DES)), %ax
+	movw $(gdtselector(KDATA_DES)), %ax
 	movw %ax, %ds
 	movw %ax, %es
@@ -304,5 +304,5 @@
 	 * Switch to kernel selectors.
 	 */
-	movl $(GDT_SELECTOR(KDATA_DES)), %eax
+	movl $(gdtselector(KDATA_DES)), %eax
 	movl %eax, %ds
 	movl %eax, %es
@@ -407,5 +407,5 @@
 	 * Switch to kernel selectors.
 	 */
-	movl $(GDT_SELECTOR(KDATA_DES)), %eax
+	movl $(gdtselector(KDATA_DES)), %eax
 	movl %eax, %ds
 	movl %eax, %es
@@ -416,5 +416,5 @@
 	 */
 	xorl %eax, %eax
-	cmpl $(GDT_SELECTOR(KTEXT_DES)), ISTATE_OFFSET_CS(%esp)
+	cmpl $(gdtselector(KTEXT_DES)), ISTATE_OFFSET_CS(%esp)
 	cmovnzl %eax, %ebp
 
Index: kernel/arch/ia32/src/bios/bios.c
===================================================================
--- kernel/arch/ia32/src/bios/bios.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/bios/bios.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -36,6 +36,4 @@
 #include <typedefs.h>
 
-#define BIOS_EBDA_PTR  0x40e
-
 uintptr_t ebda = 0;
 
Index: kernel/arch/ia32/src/boot/boot.S
===================================================================
--- kernel/arch/ia32/src/boot/boot.S	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/boot/boot.S	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -78,8 +78,8 @@
 	
 	/* Initialize Global Descriptor Table register */
-	lgdtl bootstrap_gdtr
+	lgdtl KA2PA(bootstrap_gdtr)
 	
 	/* Kernel data + stack */
-	movw $GDT_SELECTOR(KDATA_DES), %cx
+	movw $gdtselector(KDATA_DES), %cx
 	movw %cx, %es
 	movw %cx, %fs
@@ -88,5 +88,5 @@
 	movw %cx, %ss
 	
-	jmpl $GDT_SELECTOR(KTEXT_DES), $multiboot_meeting_point
+	jmpl $gdtselector(KTEXT_DES), $multiboot_meeting_point
 	multiboot_meeting_point:
 	
@@ -514,8 +514,4 @@
 page_directory:
 	.space 4096, 0
-
-bootstrap_gdtr:
-	.word GDT_SELECTOR(GDT_ITEMS)
-	.long KA2PA(gdt)
 
 grub_eax:
Index: kernel/arch/ia32/src/boot/vesa_real.inc
===================================================================
--- kernel/arch/ia32/src/boot/vesa_real.inc	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/boot/vesa_real.inc	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -30,5 +30,5 @@
 .code32
 vesa_init:
-	jmp $GDT_SELECTOR(VESA_INIT_DES), $vesa_init_real - vesa_init
+	jmp $gdtselector(VESA_INIT_DES), $vesa_init_real - vesa_init
 
 .code16
@@ -335,5 +335,5 @@
 		vesa_leave_real2:
 		
-			ljmpl $GDT_SELECTOR(KTEXT32_DES), $(vesa_init_protected - vesa_init + VESA_INIT_SEGMENT << 4)
+			ljmpl $gdtselector(KTEXT32_DES), $(vesa_init_protected - vesa_init + VESA_INIT_SEGMENT << 4)
 	
 	no_mode:
Index: kernel/arch/ia32/src/boot/vesa_ret.inc
===================================================================
--- kernel/arch/ia32/src/boot/vesa_ret.inc	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/boot/vesa_ret.inc	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -7,5 +7,5 @@
 	
 	/* Kernel data + stack */
-	movw $GDT_SELECTOR(KDATA_DES), %cx
+	movw $gdtselector(KDATA_DES), %cx
 	movw %cx, %es
 	movw %cx, %fs
@@ -14,3 +14,3 @@
 	movw %cx, %ss
 	
-	jmpl $GDT_SELECTOR(KTEXT_DES), $vesa_meeting_point
+	jmpl $gdtselector(KTEXT_DES), $vesa_meeting_point
Index: kernel/arch/ia32/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia32/src/ddi/ddi.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/ddi/ddi.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -153,5 +153,5 @@
 	 */
 	gdt_p[TSS_DES].access = AR_PRESENT | AR_TSS | DPL_KERNEL;
-	tr_load(GDT_SELECTOR(TSS_DES));
+	tr_load(gdtselector(TSS_DES));
 	
 	/*
Index: kernel/arch/ia32/src/mm/frame.c
===================================================================
--- kernel/arch/ia32/src/mm/frame.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/mm/frame.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -131,6 +131,17 @@
 			if (last_frame < ALIGN_UP(new_base + new_size, FRAME_SIZE))
 				last_frame = ALIGN_UP(new_base + new_size, FRAME_SIZE);
-		} else if ((e820table[i].type == MEMMAP_MEMORY_ACPI) ||
-		    (e820table[i].type == MEMMAP_MEMORY_NVS)) {
+		}
+		
+		if (e820table[i].type == MEMMAP_MEMORY_RESERVED) {
+			/* To be safe, make the reserved zone possibly larger */
+			uint64_t new_base = ALIGN_DOWN(base, FRAME_SIZE);
+			uint64_t new_size = ALIGN_UP(size + (base - new_base),
+			    FRAME_SIZE);
+			
+			zone_create(ADDR2PFN(new_base), SIZE2FRAMES(new_size), 0,
+			    ZONE_RESERVED);
+		}
+		
+		if (e820table[i].type == MEMMAP_MEMORY_ACPI) {
 			/* To be safe, make the firmware zone possibly larger */
 			uint64_t new_base = ALIGN_DOWN(base, FRAME_SIZE);
@@ -140,12 +151,4 @@
 			zone_create(ADDR2PFN(new_base), SIZE2FRAMES(new_size), 0,
 			    ZONE_FIRMWARE);
-		} else {
-			/* To be safe, make the reserved zone possibly larger */
-			uint64_t new_base = ALIGN_DOWN(base, FRAME_SIZE);
-			uint64_t new_size = ALIGN_UP(size + (base - new_base),
-			    FRAME_SIZE);
-			
-			zone_create(ADDR2PFN(new_base), SIZE2FRAMES(new_size), 0,
-			    ZONE_RESERVED);
 		}
 	}
@@ -200,5 +203,5 @@
 #ifdef CONFIG_SMP
 		/* Reserve AP real mode bootstrap memory */
-		frame_mark_unavailable(AP_BOOT_OFFSET >> FRAME_WIDTH,
+		frame_mark_unavailable(AP_BOOT_OFFSET >> FRAME_WIDTH, 
 		    (hardcoded_unmapped_ktext_size +
 		    hardcoded_unmapped_kdata_size) >> FRAME_WIDTH);
Index: kernel/arch/ia32/src/pm.c
===================================================================
--- kernel/arch/ia32/src/pm.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/pm.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -75,6 +75,6 @@
 	/* VESA Init descriptor */
 #ifdef CONFIG_FB
-	{ 0xffff, 0, VESA_INIT_SEGMENT >> 12, AR_PRESENT | AR_CODE | DPL_KERNEL, 0xf, 0, 0, 0, 0, 0 }
-#endif
+	{ 0xffff, 0, VESA_INIT_SEGMENT>>12, AR_PRESENT | AR_CODE | DPL_KERNEL, 0xf, 0, 0, 0, 0, 0 }
+#endif	
 };
 
@@ -86,8 +86,6 @@
 
 /* gdtr is changed by kmp before next CPU is initialized */
-ptr_16_32_t gdtr = {
-	.limit = sizeof(gdt),
-	.base = (uintptr_t) gdt
-};
+ptr_16_32_t bootstrap_gdtr = { .limit = sizeof(gdt), .base = KA2PA((uintptr_t) gdt) };
+ptr_16_32_t gdtr = { .limit = sizeof(gdt), .base = (uintptr_t) gdt };
 
 void gdt_setbase(descriptor_t *d, uintptr_t base)
@@ -130,5 +128,5 @@
 
 		d->unused = 0;
-		d->selector = GDT_SELECTOR(KTEXT_DES);
+		d->selector = gdtselector(KTEXT_DES);
 
 		if (i == VECTOR_SYSCALL) {
@@ -285,5 +283,5 @@
 	 * to its own TSS. We just need to load the TR register.
 	 */
-	tr_load(GDT_SELECTOR(TSS_DES));
+	tr_load(gdtselector(TSS_DES));
 	
 	clean_IOPL_NT_flags();    /* Disable I/O on nonprivileged levels and clear NT flag. */
Index: kernel/arch/ia32/src/proc/scheduler.c
===================================================================
--- kernel/arch/ia32/src/proc/scheduler.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/proc/scheduler.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -67,5 +67,5 @@
 	/* Set kernel stack for CPL3 -> CPL0 switch via interrupt */
 	CPU->arch.tss->esp0 = kstk;
-	CPU->arch.tss->ss0 = GDT_SELECTOR(KDATA_DES);
+	CPU->arch.tss->ss0 = gdtselector(KDATA_DES);
 	
 	/* Set up TLS in GS register */
Index: kernel/arch/ia32/src/syscall.c
===================================================================
--- kernel/arch/ia32/src/syscall.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/syscall.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -45,5 +45,5 @@
 
 	/* set kernel mode CS selector */
-	write_msr(IA32_MSR_SYSENTER_CS, GDT_SELECTOR(KTEXT_DES));
+	write_msr(IA32_MSR_SYSENTER_CS, gdtselector(KTEXT_DES));
 	/* set kernel mode entry point */
 	write_msr(IA32_MSR_SYSENTER_EIP, (uint32_t) sysenter_handler);
Index: kernel/arch/ia32/src/userspace.c
===================================================================
--- kernel/arch/ia32/src/userspace.c	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/arch/ia32/src/userspace.c	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -75,11 +75,11 @@
 		"iret\n"
 		:
-		: [udata_des] "i" (GDT_SELECTOR(UDATA_DES) | PL_USER),
+		: [udata_des] "i" (gdtselector(UDATA_DES) | PL_USER),
 		  [stack_size] "r" ((uint8_t *) kernel_uarg->uspace_stack + THREAD_STACK_SIZE),
 		  [ipl] "r" (ipl),
-		  [utext_des] "i" (GDT_SELECTOR(UTEXT_DES) | PL_USER),
+		  [utext_des] "i" (gdtselector(UTEXT_DES) | PL_USER),
 		  [entry] "r" (kernel_uarg->uspace_entry),
 		  [uarg] "r" (kernel_uarg->uspace_uarg),
-		  [tls_des] "r" (GDT_SELECTOR(TLS_DES))
+		  [tls_des] "r" (gdtselector(TLS_DES))
 		: "eax");
 	
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision 7431b66531a16a53dda757d3e07d0ac028368f72)
+++ kernel/genarch/Makefile.inc	(revision db4ec8d433d5a57e9661bceeab3b1ffff2adb1ff)
@@ -90,9 +90,4 @@
 endif
 
-ifeq ($(CONFIG_S3C24XX_IRQC),y)
-	GENARCH_SOURCES += \
-		genarch/src/drivers/s3c24xx_irqc/s3c24xx_irqc.c
-endif
-
 ifeq ($(CONFIG_S3C24XX_UART),y)
 	GENARCH_SOURCES += \
